local waitTable = {};
local waitFrame = nil;

-- original positions
local original = {};

original["MultiBarRightButton1"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=0, scale=1.0, alpha=1.0 };
original["MultiBarRightButton2"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-42, scale=1.0, alpha=1.0 };
original["MultiBarRightButton3"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-84, scale=1.0, alpha=1.0 };
original["MultiBarRightButton4"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-126, scale=1.0, alpha=1.0 };
original["MultiBarRightButton5"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-168, scale=1.0, alpha=1.0 };
original["MultiBarRightButton6"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-210, scale=1.0, alpha=1.0 };
original["MultiBarRightButton7"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-252, scale=1.0, alpha=1.0 };
original["MultiBarRightButton8"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-294, scale=1.0, alpha=1.0 };
original["MultiBarRightButton9"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-336, scale=1.0, alpha=1.0 };
original["MultiBarRightButton10"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-378, scale=1.0, alpha=1.0 };
original["MultiBarRightButton11"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-420, scale=1.0, alpha=1.0 };
original["MultiBarRightButton12"] = { point="TOP", relativeTo="MultiBarRight", relativePoint="TOP", x=0, y=-464, scale=1.0, alpha=1.0 };

original["MultiBarLeftButton1"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=0, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton2"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-42, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton3"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-84, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton4"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-126, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton5"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-168, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton6"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-210, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton7"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-252, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton8"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-294, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton9"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-336, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton10"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-378, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton11"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-420, scale=1.0, alpha=1.0 };
original["MultiBarLeftButton12"] = { point="TOP", relativeTo="MultiBarLeft", relativePoint="TOP", x=0, y=-464, scale=1.0, alpha=1.0 };


-- saved positions
MovableActionButtons = {};
MovableActionButtons.positions = {};

MovableActionButtons.active = false;

local hover = nil;

function MAB_Init()
    SLASH_MOVABLEACTIONBUTTONS1 = "/mab";
    SlashCmdList["MOVABLEACTIONBUTTONS"] = function(msg)
        MAB_SlashCommandHandler(msg);
    end

    MAB_StartDelay(2, MAB_InitButtons);
end

function MAB_InitButtons()
    for name, button in pairs(original) do
        MAB_InitButton(name);
    end

    MultiBarLeft:SetMovable(true);
    MultiBarRight:SetMovable(true);
    MultiBarLeft:SetUserPlaced(true);
    MultiBarRight:SetUserPlaced(true);
end

function MAB_ShowHelp()
    DEFAULT_CHAT_FRAME:AddMessage("|cff3399ffNirriti's|r MovableActionButtons Help:", 1.0, 1.0, 1.0, 1, 10);

    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00/mab on|r make buttons movable", 1.0, 1.0, 1.0, 1, 10);
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00/mab off|r make buttons unmovable", 1.0, 1.0, 1.0, 1, 10);
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00/mab resetall|r reset all positions, size and transparency", 1.0, 1.0, 1.0, 1, 10);
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00/mab reset|r resets the actually hovered button", 1.0, 1.0, 1.0, 1, 10);
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00/mab scale #|r sets the scale for the actually hovered button", 1.0, 1.0, 1.0, 1, 10);
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00/mab alpha #|r sets the transparency for the actually hovered button", 1.0, 1.0, 1.0, 1, 10);
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00/mab save|r save shared settings", 1.0, 1.0, 1.0, 1, 10);
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00/mab load|r load shared settings", 1.0, 1.0, 1.0, 1, 10);
end

function MAB_SlashCommandHandler(msg)
    if (not msg or msg == "" or msg == "?" or msg == "help") then
        MAB_ShowHelp();
    elseif (msg == "reload") then
        ReloadUI();
    elseif (msg == "on") then
        MovableActionButtons.active = true;
    elseif (msg == "off") then
        MovableActionButtons.active = false;
    elseif (msg == "resetall") then
        MAB_ResetAll();
    elseif (msg == "reset") then
        MAB_Reset();
    elseif (msg == "save") then
        MAB_SaveShared();
    elseif (msg == "load") then
        MAB_LoadShared();
    elseif (string.find(msg, "scale") == 1) then
        local str_scale = string.sub(msg, 7);
        local scale = tonumber(str_scale);

        if (scale and scale >= 0.1 and scale <= 4) then
            MAB_SetScale(scale);
        else
            DEFAULT_CHAT_FRAME:AddMessage("scale: from 0.1 to 4.0", 1.0, 0, 0, 1, 10);
        end
    elseif (string.find(msg, "alpha") == 1) then
        local str_alpha = string.sub(msg, 7);
        local alpha = tonumber(str_alpha);

        if (alpha and alpha >= 0.0 and alpha <= 1.0) then
            MAB_SetAlpha(alpha);
        else
            DEFAULT_CHAT_FRAME:AddMessage("alpha: from 0.0 to 1.0", 1.0, 0, 0, 1, 10);
        end
    end
end

function MAB_SaveShared()
    MovableActionButtonsShared = MovableActionButtons;
end

function MAB_LoadShared()
    MovableActionButtons = MovableActionButtonsShared or MovableActionButtons;
    MAB_InitButtons();
end


function MAB_InitButton(name)
    local button = _G[name];

    button:SetMovable(true);
    button:SetUserPlaced(true);

    MAB_UpdateButtonData(name);

    button:HookScript("OnEnter", MAB_OnEnter);
    button:HookScript("OnLeave", MAB_OnLeave);
    button:HookScript("OnDragStart", MAB_OnDragStart);
    button:HookScript("OnDragStop", MAB_OnDragStop);
end

function MAB_UpdateButtonData(name)
    local pos = MovableActionButtons.positions[name];

    local y_offset = 0;

    if (pos == nil) then
        pos = original[name];
        y_offset = -50;
    end

    local button = _G[name];

    button:ClearAllPoints();
    button:SetPoint(pos.point, _G[pos.relativeTo], pos.relativePoint, pos.x, pos.y + y_offset);

    button:SetScale(pos.scale or 1.0);
    button:SetAlpha(pos.alpha or 1.0);

    MAB_SetTextScale(button, pos.scale or 1.0);
end

function MAB_SetTextScale(button, scale)

    local fontName, fontHeight, fontFlags;

    -- rescale count
    local counttext = _G[button:GetName().."Count"];
    fontName, fontHeight, fontFlags = counttext:GetFont();
    counttext:SetFont(fontName, 14/scale, fontFlags);

    -- rescale hotkey
    local hotkey = _G[button:GetName().."HotKey"];
    fontName, fontHeight, fontFlags = hotkey:GetFont();
    hotkey:SetFont(fontName, 12/scale, fontFlags);

    -- rescale buttonname
    local buttonname = _G[button:GetName().."Name"];
    fontName, fontHeight, fontFlags = buttonname:GetFont();
    buttonname:SetFont(fontName, 10/scale, fontFlags);
end

function MAB_OnEnter(self)
    hover = self;
end

function MAB_OnLeave(self)
    hover = nil;
end

local isMoving = false;
function MAB_OnDragStart(self, button)
    if (MovableActionButtons.active and button == "RightButton") then
        if (IsControlKeyDown()) then
            self:ClearAllPoints();
            self:StartMoving();
            isMoving = true;
        end
    end
end

function MAB_OnDragStop(self, button)
    self:StopMovingOrSizing();

    if (isMoving) then
        isMoving = false;

        MAB_NormalizeButtonPosition(self);

        local name = self:GetName();
        local point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1);

        local scale = 1.0;
        local alpha = 1.0;

        if (MovableActionButtons.positions[name]) then
            scale = MovableActionButtons.positions[name].scale or 1.0;
            alpha = MovableActionButtons.positions[name].alpha or 1.0;
        end

        MovableActionButtons.positions[name] = { point=point, relativeTo="UIParent", relativePoint=relativePoint, x=xOfs, y=yOfs, scale=scale, alpha=alpha };
    end
end

function MAB_NormalizeButtonPosition(self)

    if (not self) then
        return;
    end

    local point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1);

    xOfs = ceil(xOfs);
    yOfs = ceil(yOfs);

    self:ClearAllPoints();
    self:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);
end

function MAB_Reset()
    if (hover ~= nil) then
        MAB_ResetButton(hover:GetName());
    end
end

function MAB_SetScale(scale)
    if (hover ~= nil) then
        MovableActionButtons.positions[hover:GetName()].scale = scale;
        MAB_UpdateButtonData(hover:GetName());
    end
end

function MAB_SetAlpha(alpha)
    if (hover ~= nil) then
        MovableActionButtons.positions[hover:GetName()].alpha = alpha;
        MAB_UpdateButtonData(hover:GetName());
    end
end

function MAB_ResetAll()
    for name, button in pairs(original) do
        MAB_ResetButton(name);
    end
end

function MAB_ResetButton(name)
    MovableActionButtons.positions[name] = nil;
    MAB_UpdateButtonData(name);
end

local debug = true;

-- functions

function mab_debug(value, name)
    if (not debug) then
        return;
    end

    if (name) then
        DEFAULT_CHAT_FRAME:AddMessage("debug "..name..": "..(value or "nil"), 1.0, 1.0, 1.0, 1, 10);
    else
        DEFAULT_CHAT_FRAME:AddMessage("debug: "..(value or "nil"), 1.0, 1.0, 1.0, 1, 10);
    end
end

function MAB_StartDelay(delay, func, ...)
    if(type(delay)~="number" or type(func)~="function") then
        return false;
    end

    if(waitFrame == nil) then
        waitFrame = CreateFrame("Frame","MAB_WaitFrame", UIParent);
        waitFrame:SetScript("onUpdate",function (self,elapse)
            local count = #waitTable;
            local i = 1;

            while(i<=count) do
                local waitRecord = tremove(waitTable,i);
                local d = tremove(waitRecord,1);
                local f = tremove(waitRecord,1);
                local p = tremove(waitRecord,1);

                if(d>elapse) then
                    tinsert(waitTable,i,{d-elapse,f,p});
                    i = i + 1;
                else
                    count = count - 1;
                    f(unpack(p));
                end
            end
        end);
    end

    tinsert(waitTable,{delay,func,{...}});

    return true;
end

MAB_Init();
